java异常处理与自定义异常类

异常作用:在运行java代码时,如果有错是无法编译成功的,IDE会给出一串错误说明;如果编译通过,程序运行过程中,JVM检测出一个不可执行的操作,会出现运行时错误,IDE也会给出错误说明;这就是java异常类的作用。

异常分类:java中的异常都是继承自Throwable类,Throwable类e的两个子类为Error与Exception。Exception有一个子类RuntimeException,它描述的是程序设计错误 。RuntimeException、Error以及它们的子类都称为免检异常;所有其它异常称为必检异常,需要程序员检查并通过try-catch块来处理。

操作:java的异常处理模型基于三种操作:声明异常(throws)、抛出异常(throw)、捕获异常(try-catch-finally)。

java当前执行的语句必属于某个方法,因此该方法需要声明它可能抛出的必检异常类型,通过throws关键字声明。比如:

public void myMethod () throws IOException

通常通过条件判断方法中出现异常,就要抛出它。比如

throw new IOException(parameter)

当调用方法时,我们需要捕获抛出的异常,用try-catch块。比如

`try{

statements;

}

catch(IOException ex){

ex.printStackTrace();

}`

一个自定义的异常例子

我们自定义一个异常类MyException,它的功能是输出“出现异常”来提示我们出现异常。people类中的setSex方法声明并抛出此异常。测试类中调用了setSex方法,因为该方法可能会抛出异常,所以在调用的地方我们用try-catch块来处理可能捕获的异常。

public class TestMyException {
    public static void main(String[] args) {
        // TODO Auto-generated method stub
        People p=new People();
        try {
            p.setSex("Male");
        } catch (MyException e) {
            e.printStackTrace();//输出异常信息
        }
    }
}
class MyException extends Exception{
    public MyException(String message) {
        super("出现异常:"+message);
    }
}

class People {
    String name="";
    int age=0;
    String sex;
    public String getSex()
    {
        return sex;
    }
    public void setSex(String sex) throws MyException{
        if("男".equals(sex) || "女".equals(sex))
        {
            this.sex=sex;
        }
        else {
            throw new MyException("性别必须是男或者女");
        }
    }
}

原文 

https://segmentfault.com/a/1190000022049512

本站部分文章源于互联网,本着传播知识、有益学习和研究的目的进行的转载,为网友免费提供。如有著作权人或出版方提出异议,本站将立即删除。如果您对文章转载有任何疑问请告之我们,以便我们及时纠正。

PS:推荐一个微信公众号: askHarries 或者qq群:474807195,里面会分享一些资深架构师录制的视频录像:有Spring,MyBatis,Netty源码分析,高并发、高性能、分布式、微服务架构的原理,JVM性能优化这些成为架构师必备的知识体系。还能领取免费的学习资源,目前受益良多

转载请注明原文出处:Harries Blog™ » java异常处理与自定义异常类

赞 (0)
分享到:更多 ()

评论 0

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址